clear all
load('IOO_params.mat')
%% RefCav motion estimation 11/22 (AOM was turned off)
% Define noisebudget model parameters
loopNames = {'FSS total','NPRO_PZT','BEOM','NPRO_TEMP','IMC total','AOM','MCE SUS','CARM'};
noiseModel = 'IOO';
% servos
CG = 26;
FG = 30;
TTFSS_Gain = set_TTFSS_Gain(CG,FG,-1);
set_FB('K1:PSL-TTFSS_TEMP_FILTER',FB,0,[])

IN1GAIN = -20;
K1IMC_MCL_GAIN = -40;
CMS_SW = set_CMS_SW('IN1','IN1GAIN',mn_CMSgain(IN1GAIN),'SLOWPOL',-1);
set_FB('K1:IMC-MCL_SERVO', FB, K1IMC_MCL_GAIN, [3 10]);

IN1GAIN = -32;
CMS_SW_CARM = set_CMS_SW();
set_FB('K1:LSC-CARM_SERVO', FB, 0, []);


% Optical gains
CavOpgain = containers.Map;
CavOpgain('IMC') = Cav('LPF_IMC_1122');
CavOpgain('RefCav') = Cav('LPF_RefCav_1122');
CavOpgain('CARM') = 0;

% Cavity low path filter
CavOpgain = containers.Map;
CavLPF('IMC') = mnzpk([],[Cav('Cpole_IMC')],1);
CavLPF('RefCav') = mnzpk([],[Cav('Cpole_RefCav')],1);
CavLPF('CARM') = 0;


% OLG check
% check_OLG_1102

% noise budget
% close all
noiseModel = 'IOO';
% Error signal
dof = 'ERR_IMC_motion_RefCav';
for KOACH = {'on','off'};
    [freq, sp] = import_1122data(KOACH,'ERR_IMC');
    % Noises
    Noise = make_Noise(freq, Servo_0dB,{'seismic_IMC', 'motion_RefCav'});

    SW = ones(1,length(loopNames));
    SW(mnismember(loopNames,'AOM')) = 0;
    SW(mnismember(loopNames,'CARM')) = 0;
    % Compute noises
    [noises, sys] = nbFromSimulink(noiseModel, freq, 'dof', dof);
    saveFunctionCache();    % save cached outputs
    nb = nbGroupNoises(noiseModel, noises, sys);
    nb.sortModel();
    matlabNoisePlot(nb);
    
    [RefCav_Noise(['ff_KOACH_' KOACH{1}]),RefCav_Noise(['KOACH_' KOACH{1}])] = ...
        mntrim(30,1e6,noises{1}.f,noises{1}.asd);
end
save('Noise budget/RefCav_Noise.mat','RefCav_Noise')

%% IMC sus FB signal NB
close all
noiseModel = 'IOO';
% importdata
mnimportdata('F1122_3.txt',Freq,Abs,Phase,'IMC_SUS_FB','sp','density');
[temp_ff1, temp_abs1] = mntrim(0,2,Freq('IMC_SUS_FB'),Abs('IMC_SUS_FB'));
[temp_ff2, temp_abs2] = mntrim(2.1,1e9,Freq('IMC_SUS_FB'),Abs('IMC_SUS_FB')); 
temp_ff2 = downsample(temp_ff2,50);
temp_abs2 = downsample(temp_abs2,50);
Freq('IMC_SUS_FB') = [temp_ff1; temp_ff2];
Abs('IMC_SUS_FB') = [temp_abs1; temp_abs2];

freq = Freq('IMC_SUS_FB');
sp = Abs('IMC_SUS_FB');


dof = 'FB_IMCsus_seismic_IMC';
KOACH = 'off';

% Noises
Noise = make_Noise(freq, Servo_0dB,{'seismic_IMC'},'KOACH_off');

SW = ones(1,length(loopNames));
SW(mnismember(loopNames,'AOM')) = 0;
SW(mnismember(loopNames,'CARM')) = 0;
% Compute noises
[noises, sys] = nbFromSimulink(noiseModel, freq, 'dof', dof);
saveFunctionCache();    % save cached outputs
nb = nbGroupNoises(noiseModel, noises, sys);
nb.sortModel();
matlabNoisePlot(nb);
Seismic_IMC = containers.Map;
[Seismic_IMC('ff'), Seismic_IMC('Abs')] = mntrim(1e-6,1.5,noises{1}.f,noises{1}.asd);
save('Noise budget/IMC_Seismic.mat','Seismic_IMC');

%% IMC sus FB signal NB
close all
noiseModel = 'IOO';
% importdata
mnimportdata('F1122_3.txt',Freq,Abs,Phase,'IMC_SUS_FB','sp','density');
[temp_ff1, temp_abs1] = mntrim(0,2,Freq('IMC_SUS_FB'),Abs('IMC_SUS_FB'));
[temp_ff2, temp_abs2] = mntrim(2.1,1e9,Freq('IMC_SUS_FB'),Abs('IMC_SUS_FB')); 
temp_ff2 = downsample(temp_ff2,50);
temp_abs2 = downsample(temp_abs2,50);
Freq('IMC_SUS_FB') = [temp_ff1; temp_ff2];
Abs('IMC_SUS_FB') = [temp_abs1; temp_abs2];

freq = Freq('IMC_SUS_FB');
sp = Abs('IMC_SUS_FB');


dof = 'FB_IMCsus';
KOACH = 'off';

% Noises
Noise = make_Noise(freq, Servo_0dB,{},'KOACH_off');

SW = ones(1,length(loopNames));
SW(mnismember(loopNames,'AOM')) = 0;
SW(mnismember(loopNames,'CARM')) = 0;
% Compute noises
[noises, sys] = nbFromSimulink(noiseModel, freq, 'dof', dof);
saveFunctionCache();    % save cached outputs
nb = nbGroupNoises(noiseModel, noises, sys);
nb.sortModel();
matlabNoisePlot(nb);
NPRO_noise = containers.Map;
[NPRO_noise('ff'), NPRO_noise('Abs')] = mntrim(1e-6,1e6,noises{1}.f,noises{1}.asd);

